#include <stdio.h>
#include <stdlib.h>
#define STACKSIZE 5 //antud nite puhul defineerime ra stacki maksimaalse suuruse

typedef struct {
    size_t stackSize; //stacki maksimaalne suurus
    size_t stackPointer; //mitmenda elemendi peale stack nitab
    double *items; //stacki elementidele massiiv
} STACK;


STACK *create(size_t st); //stackile mlu andmine
void push(STACK *ps, double x);
double pop(STACK *ps);
void display(STACK *ps); //tunnitle omane funktsioon kikide stacki elementide popimiseks
int menu();
void destroy(STACK *ps); //stacki mlust eemaldamine
int peek(STACK *ps); //funktsioon piilumaks stacki pealmist elementi, kuid eemaldamist ei tehta


int main(void){
    int valik=1, num; //valik on men valiku jaoks abimuutuja. Num on pushitava numbri jaoks
    STACK *minuStack = create(STACKSIZE); //stacki deklamine ja mlu andmine
    while(valik) {
        valik = menu(); //kuvame men valikud
        switch(valik){
            case 0:
                destroy(minuStack);
                return 0;
            case 1:
                printf("Number mis stacki panna\n> ");
                scanf("%d", &num);
                push(minuStack, num);
                break;
            case 2:
                num = pop(minuStack);
                if(num)
                    printf("tagastus: %d\n", num);
                break;
            case 3:
                num = peek(minuStack);
                if(num>=0)
                    printf("Pealmine element: %d\n", num);
                break;
            case 4:
                display(minuStack);
                break;
        }
    }
    return 0;
}

STACK *create(size_t st){
    STACK *ps; //ajutine viit
    ps = (STACK*) malloc (sizeof(STACK)); //anname stackile mlu
    ps -> stackSize = st; //mrame ra stacki suuruse
    ps -> stackPointer = 0; //paneme nitama nullindale elemendile
    ps -> items = (double*)malloc(sizeof(double) * ps -> stackSize); //anname stacki elementidele mlu
    return ps;
}

void push(STACK *ps, double x) {
    if (ps->stackPointer == ps->stackSize)
        puts("Error: stack overflow\n");
    else
        *(ps -> items + (ps -> stackPointer++)) = x;
}

double pop(STACK *ps) {
    if (ps->stackPointer == 0) {
        puts("\nError: stack underflow\n");
        return 0;
    } else
        return ps->items[--ps->stackPointer];
}

int menu(){
    int temp;
    printf("\n\n1 - push\n2 - pop\n3 - peek\n4 - display\n0 - exit\n> ");
    scanf("%d", &temp);
    return temp;
}

void display(STACK *ps){
    while(ps->stackPointer != 0)
        printf("tagastus: %.2lf\n", pop(ps));
}

void destroy(STACK *ps){
    free(ps->items); //vabastame esmalt stacki elementide mlu, sest muidu ei ole meil enam seda viita ja mlu vabastada ei saaks
    free(ps); //seejrel vabastame stacki enda mlu
}

int peek(STACK *ps) {
    if (ps->stackPointer == 0) {
        puts("\nError: stack empty\n");
        return -1;
    } else
        return *(ps -> items + (ps -> stackPointer) - 1);
}
